#include "board.h"
#include <iostream>
#include <sstream>
#include <string>

std::ostream& operator<<(std::ostream& os,Color const& c)
{
  switch(c){
  case RED: return os << '+';
  case EMPTY: return os << '.';
  case BLUE: return os << '-';
  case EDGE: return os << '#';
  default:
    assert(0);
  }
}

std::istream& operator>>(std::istream& is,Color & color){
  std::string s;
  is >> s;
  if(s == "-") color=BLUE;
  else if(s == "+") color=RED;
  else color=EMPTY;
  return is;
}


Board::Board()
{
  std::fill(&board[0],&board[SIZE],EDGE);
  for(int i=0;i<25;i++)
    board[pos2IndexTable.getIndex(i)]=EMPTY;
}

std::istream& operator>>(std::istream& is,Board & b){
  for(int y=0;y<3;y++){
    for(int x=0;x<4;x++) is >> b[y*4+x];
    for(int x=0;x<3;x++) is >> b[16+y*3+x];
  }
  for(int x=0;x<4;x++) is >> b[3*4+x];
  return is;
}
Board::Board(const char *s){
  std::fill(&board[0],&board[SIZE],EDGE);
  std::istringstream iss(s);
  iss >> *this;
}

std::ostream& operator<<(std::ostream& os,Board const& b)
{
  for(int y=0;y<3;y++){
    for(int x=0;x<4;x++) os << b[y*4+x] << ' ';
    os << std::endl << ' ';
    for(int x=0;x<3;x++) os << b[16+y*3+x] << ' ';
    os << std::endl;
  }
  for(int x=0;x<4;x++) os << b[3*4+x] << ' ';
  return os << std::endl << ' ';
}
