#ifndef _BOARD_TABLE_H
#define _BOARD_TABLE_H
#include "packedBoard.h"
#include "board.h"
#include <vector>
#include <iostream>
using namespace std;

struct BoardTable{
  vector<PackedBoard> allBoard;
  vector<char> winOrLose;
  vector<vector<int> > allNexts;
  int s2i(hash_map<PackedBoard,int>& s2iMap,PackedBoard const& s){
    hash_map<PackedBoard,int>::iterator it=s2iMap.find(s);
    if(it!=s2iMap.end())
      return it->second;
    int index=allBoard.size();
    allBoard.push_back(s);
    winOrLose.push_back(0); // unknown
    allNexts.push_back(vector<int>());
    s2iMap[s]=index;
    return index;
  }
  void makeWinLose();
  void make();
  void showState(ostream& os,int index){
    Board state;
    state.init(allBoard[index]);
    os << "-----------------" << endl;
    os << state << endl;
    os << static_cast<int>(winOrLose[index]) << endl;
  }
  void save(char * filename);
  void load(char * filename);
};
#endif /* _BOARD_TABLE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
