/**
 * $B>WFM$N>/$J$$%O%C%7%e4X?t$r5a$a$k!%(B
 */
#include "boardTable.h"
#include "playTable.h"
#include <iostream>
#include <algorithm>
#include <fstream>
#include <vector>
using namespace std;


unsigned int hash2(PackedBoard packed)
{
  packed>>=7ll;
  unsigned int ret=0u;
  for(int i=0;i<25;i++){
    ret+=(static_cast<int>(packed)&0x3)*(rnds[24-i]&0x7ffff);
    packed>>=2ull;
  }
  ret&=0x7ffff;
  return static_cast<unsigned int>(ret);
}

int main()
{
  BoardTable table;
  table.load("unreachable.dat");
  size_t size=table.winOrLose.size();
  vector<int> checkWinOrLose(size,0);
  Board board;
  for(size_t i=0;i<table.winOrLose.size();i++){
    if(table.winOrLose[i]==100) checkWinOrLose[i]=table.winOrLose[i];
    else if(table.winOrLose[i]<=-99) checkWinOrLose[i]=table.winOrLose[i];
    else if(table.winOrLose[i]>0)  checkWinOrLose[i]=1;
    else if(table.winOrLose[i]<0){
      board.init(table.allBoard[i]);
      board.revColor();
      if(board.canWin()) checkWinOrLose[i]= -2;
      else checkWinOrLose[i]= -1;
    }
  }
  for(int nmoves=1;;nmoves++){
    int changed=0;
    for(size_t i=0;i<table.winOrLose.size();i++){
      if(checkWinOrLose[i]==1){
	for(size_t j=0;j<table.allNexts[i].size();j++){
	  int k=table.allNexts[i][j];
	  if(checkWinOrLose[k]< -2){
	    checkWinOrLose[i]= -checkWinOrLose[k]-1;
	    changed++;
	    break;
	  }
	}
      }
      else if(checkWinOrLose[i]== -2){
	int minval=101;
	for(size_t j=0;j<table.allNexts[i].size();j++){
	  int k=table.allNexts[i][j];
	  minval=std::min(minval,checkWinOrLose[k]);
	}
	if(minval>1){
	  checkWinOrLose[i]= -minval+1;
	  changed++;
	}
      }
    }
    cerr << "nmoves=" << nmoves << ",changed=" << changed << endl;
    if(changed==0)break;
  }
  vector<vector<PlayTable> > playBlock(0x80000);
  for(size_t i=0;i<size;i++){
    PackedBoard bestNext=makeInvalid();
    int minval=101;
    for(size_t j=0;j<table.allNexts[i].size();j++){
      int tmpval=static_cast<int>(table.winOrLose[table.allNexts[i][j]]);
      if(checkWinOrLose[i]<-2)
	tmpval-=100;
      if(minval>tmpval){
	minval=tmpval;
	bestNext=table.allBoard[table.allNexts[i][j]];
      }
    }
    playBlock[hash(table.allBoard[i])].
      push_back(PlayTable(table.allBoard[i],
			  bestNext,
			  table.winOrLose[i]));
  }
  vector<int> counts(0x1000,0);
  ofstream ofs("playcheck.dat");
  for(size_t j=0;j<0x80000;j++){
    size_t k=0;
#if 1
    Board b;
    for(;k<playBlock[j].size();k++){
#if 0
      cerr << "-----" << endl;
      b.init(playBlock[j][k].packed);
      cerr << b << endl;
      cerr << static_cast<int>(playBlock[j][k].winOrLose) << endl;
      b.init(playBlock[j][k].bestNext);
      cerr << b << endl;
#endif
      ofs << playBlock[j][k];
    }
    PlayTable pt(makeInvalid(),makeInvalid(),0);
    for(;k<PlayTableFile::maxGroupSize;k++){
      ofs << pt;
    }
#else
    counts[playBlock[j].size()]++;
#endif
  }
  for(int i=0;i<0x1000;i++)
    if(counts[i]>0)
      cerr << i << "," << counts[i] << endl;
  return 0;
}
