#include "pos2IndexTable.h"
#include "board.h"

namespace {
  void rot90(int *src,int *dst,int size)
  {
    for(int y=0;y<size;y++)
      for(int x=0;x<size;x++)
	dst[y*size+x]=src[x*size+(size-1-y)];
  }
  void rot90(int *src,int *dst)
  {
    rot90(src+Board::H_INDEX,dst+Board::H_INDEX,Board::H_SIZE);
    rot90(src+Board::L_INDEX,dst+Board::L_INDEX,Board::L_SIZE);
  }
  void revVert(int *src,int *dst,int size)
  {
    for(int y=0;y<size;y++)
      for(int x=0;x<size;x++)
	dst[y*size+x]=src[(size-1-y)*size+x];
  }
  void revVert(int *src,int *dst)
  {
    revVert(src+Board::H_INDEX,dst+Board::H_INDEX,Board::H_SIZE);
    revVert(src+Board::L_INDEX,dst+Board::L_INDEX,Board::L_SIZE);
  }
};

Pos2IndexTable pos2IndexTable;

Pos2IndexTable::Pos2IndexTable()
{
  int i=0;
  for(int y=0;y<Board::H_SIZE;y++)
    for(int x=0;x<Board::H_SIZE;x++)
      index[0][i++]=y*Board::WIDTH+x+Board::Board::H_START;
  assert(i==Board::L_INDEX);
  for(int y=0;y<Board::L_SIZE;y++)
    for(int x=0;x<Board::L_SIZE;x++)
      index[0][i++]=y*Board::WIDTH+x+Board::Board::L_START;
  assert(i==25);
  rot90(&index[0][0],&index[1][0]);
  rot90(&index[1][0],&index[2][0]);
  rot90(&index[2][0],&index[3][0]);
  revVert(&index[3][0],&index[4][0]);
  rot90(&index[4][0],&index[5][0]);
  rot90(&index[5][0],&index[6][0]);
  rot90(&index[6][0],&index[7][0]);
}

std::ostream& operator<<(std::ostream& os,Pos2IndexTable const& table)
{
  for(int j=0;j<8;j++){
    if(j==0)
      os << "{{";
    else
      os << " {";
    for(int i=0;i<25;i++)
      os << table.getIndex(j,i) << ",";
    os << "}" << std::endl;
  }
  return os << "}";
}

